#!/usr/bin/env perl
use strict;
use warnings;

use FindBin qw($Bin);
use lib "$Bin/../TEBA";

use IdUnify;

use Getopt::Std;
my %opts = ();
getopts("d", \%opts);

die "specify two file names." if (@ARGV < 2);

open(F, $ARGV[0]) || die "can't open file: $ARGV[0].";
my @a = <F>;
close(F);

open(F, $ARGV[1]) || die "can't open file: $ARGV[1].";
my @b = <F>;
close(F);

my $iu = IdUnify->new();
$iu->debug_on() if ($opts{d});
$iu->set(\@a, \@b);
$iu->unify();
#print map("$_\n", $iu->get_b());


my %v;
my $id;
my %a;
foreach ($iu->get_a()) {
    if (/^B_P\s+(#\w+)\s+<>$/) {
	$id = $1;
    } elsif (/^ID_VF\s+<(\w+)>$/) {
	$a{$id} = $1;
	$v{$id} = $1;
    }
}

my %b;
foreach ($iu->get_b()) {
    if (/^B_P\s+(#\w+)\s+<>$/) {
	$id = $1;
    } elsif (/^ID_VF\s+<(\w+)>$/) {
	$b{$id} = $1;
	$v{$id} = $1;
    }
}

my %var;
foreach (keys %v) {
    $var{ join(":", ($a{$_} || ""), ($b{$_} || "")) }++;
}


my (%va, %vb);
$va{""}++; $vb{""}++;
foreach (sort { $var{$b} <=> $var{$a} } keys %var) {
    my ($a, $b) = split(":");
    if (exists $va{$a} && !exists $vb{$b}) {
	print "<=> $b\n";
    } elsif (!exists $va{$a} && exists $vb{$b}) {
	print "$a <=>\n";
    } elsif (!exists $va{$a} && !exists $vb{$b}) {
	print "$a <=> $b\n";
    }
    $va{$a}++; $vb{$b}++;
}


if (0) {
open(W, ">$ARGV[0].unified") || die "can't open file for writing: $ARGV[0].unified.";
print W map("$_\n", $iu->get_a());
close(W);

open(W, ">$ARGV[1].unified") || die "can't open file for writing: $ARGV[1].unified.";
print W map("$_\n", $iu->get_b());
close(W);
}
